#include <vector> // define std::vector
#include <iterator> // defines std::iterator_traits
#include <functional> // defines std::less
#include "input_generation.c++" // defines random_sequence()
#include "do_nothing.c++" // defines do_nothing()

template <
  typename element, 
  typename ordering,
  typename container,
  typename position
>
class experiment {
public:
  experiment (unsigned int n) {
    a = container(n, element());
    less = ordering();
  }
  void primal() {
    local_moves(a.begin(), a.end());
  }
  void dual() {
    special_cost_for_local_moves(a.begin(), a.end());
  }
private:
  unsigned int n;
  container a;
  ordering less;
};







