template <typename random_access_iterator>
void local_moves ( 
  random_access_iterator first,
  random_access_iterator past_the_end
) {
  random_access_iterator p;
  random_access_iterator q;
  for (q = past_the_end - 1; q > first; --q) {
    p = q - 1;
    std::swap(*p, *q);
  }
}

template <typename random_access_iterator>
void special_cost_for_local_moves ( 
  random_access_iterator first,
  random_access_iterator past_the_end
) {
  random_access_iterator p;
  random_access_iterator q;
  for (q = past_the_end - 1; q > first; --q) {
    p = q - 1;
  }
}
