#include <vector> // define std::vector
#include <iterator> // defines std::iterator_traits
#include <functional> // defines std::less

template <typename position, typename ordering>
void fun_if(position a, position b, const ordering& less) {
  typename std::iterator_traits<position>::difference_type top;
  typename std::iterator_traits<position>::difference_type topA;
  typename std::iterator_traits<position>::difference_type topB;
  
  for (position p = a; p < b - 1; p = p + 4) {
    if (less(*(p + 1), *p)) {
      topA = 0;    
    }
    else {
      topA = 1;
    }
    if (less(*(p + 3), *(p + 2))) {
      topB = 2;    
    }
    else {
      topB = 3;
    }
    if (less(*(p + topB), *(p + topA))) {
      top = topA;
    }
    else {
      top = topB;
    }
  }
}





